import { Component, OnInit } from '@angular/core';

declare let $;
@Component({
  selector: 'app-table',
  templateUrl: './table1.component.html',
  styleUrls: ['./table1.component.css']
})
export class Table1Component implements OnInit {
  constructor() {}

  ngOnInit() {
    setTimeout(() => { // setTimeout for letting time for dependencies to load in index.html
    let page = 0;
    let start = 0;
    let length = 0;
    function format ( d ) {
        const encrypt = d.encrypt_pass;
        let outputEncrypt = '';
        const disks = d.disk_info;
        let outputDisks = '';
        const entreprise = d.nomEntreprise;
        let outputEntreprise = '';
        const expeditionMethod = d.expedition_method;
        let outputExpeditionMethod = '';
        const typeRaid = d.type_raid;
        let outputRaid = '';
        const facturation = d.facturation;
        let outputFacturation = '';
        const typeStockage = d.type_stockage;

        if(Object.getOwnPropertyNames(facturation).length !== 0) {
            outputFacturation += '<tr><td class="info">Facturation:</td><td>';
            outputFacturation += '<table class="table table-unstriped table-bordered table-hover table-condensed" cellpadding="5" cellspacing="0" border="0" style="margin: 0; padding: 0; width:100%;">';
            outputFacturation += '<tbody>';
            if (facturation.nomEntreprise && facturation.statut === 'Entreprise') {
                outputFacturation += '<tr><td style="background-color: #e5e5e6;">Entreprise: </td>';
                outputFacturation += '<td>' + facturation.nomEntreprise + '</td><tr>';
            }
            outputFacturation += '<tr><td style="background-color: #e5e5e6;">Prénom: </td>';
            outputFacturation += '<td>' + facturation.firstname + '</td><tr>';
            outputFacturation += '<tr><td style="background-color: #e5e5e6;">Nom: </td>';
            outputFacturation += '<td>' + facturation.lastname + '</td><tr>';
            outputFacturation += '<tr><td style="background-color: #e5e5e6;">Adresse: </td>';
            outputFacturation += '<td>' + facturation.format_address + '</td><tr>';
            outputFacturation += '<tbody></table></td></tr>';
        }
            outputDisks += '<table class="table table-unstriped table-bordered table-hover table-condensed" cellpadding="5" cellspacing="0" border="0" style="margin: 0; padding: 0; width:100%;">' +
        '<thead>' +
            '<tr style="background-color: #e5e5e6;">' +
                '<th style="font-style: italic; font-weight: normal !important;">Marque</th>' +
                '<th style="font-style: italic; font-weight: normal !important;">Taile (GB)</th>' +
                '<th style="font-style: italic; font-weight: normal !important;">S/N</th>';
            if (typeStockage === 'RAID') {
                outputDisks += '<th><button class="btn btn-success btn-xs" type="button" onclick="addDisque(\''+ d._id +'\')"><i class="fa fa-plus"></i></button></th>'; 
            }
            outputDisks += '</tr>' +
        '</thead>' +
        '<tbody>';
        if (typeStockage === 'RAID') {
            for ( const i in disks) {
                outputDisks += '<tr>';
                    outputDisks += '<td>' + disks[i].marque + '</td>';
                    outputDisks += '<td>' + disks[i].taille + '</td>';
                    outputDisks += '<td>' + disks[i].serie + '</td>';
                    outputDisks += '<td><button class="btn btn-danger btn-xs" type="button" onclick="deleteDisque(\''+ d._id +'\',\''+ disks[i]._id +'\')"><i class="fa fa-close"></i></button></div></td>';
                outputDisks += '</tr>';
            }
        } else {
            for ( const i in disks) {
                if (i === '0') {
                outputDisks += '<tr>';
                    outputDisks += '<td>' + disks[i].marque + '</td>';
                    outputDisks += '<td>' + disks[i].taille + '</td>';
                    outputDisks += '<td>' + disks[i].serie + '</td>';
                outputDisks += '</tr>';
                }
            }
        }
        outputDisks += '</tbody>' +
        '</table>';
        if (!encrypt || 0 === encrypt.length) {
            outputEncrypt = 'Non encrypté';
        } else {
            outputEncrypt = encrypt;
        }
        if (!entreprise || 0 === entreprise.length) {
            outputEntreprise = '';
        } else {
            outputEntreprise = '<tr>' +
                '<td class="info">Entreprise:</td>' +
                '<td>' +
                    entreprise +
                '</td>' +
            '</tr>';
        }
        if (expeditionMethod === 'Canada Postes' && (expeditionMethod.length > 0)) {
          outputExpeditionMethod = '<tr>' +
          '<td class="info">Cananda Postes:</td>' +
          '<td>' +
              // tslint:disable-next-line:max-line-length
              '<a href="https://' + window.location.host + '/artifact/' + d.ticket + '" target="_blank" class="btn btn-primary btn-block">Étiquette</a>' +
              // tslint:disable-next-line:no-unused-expression
              '</td>' +
          '</tr>';
        } else {
          outputExpeditionMethod = '';
        }
        if ( typeRaid === 'raidDefault' || typeRaid === 'aucun' ) {
            outputRaid = '';
        } else {
            outputRaid = '<tr>' +
                '<td class="info">Type de Raid:</td>' +
                '<td>' + typeRaid + '</td>' +
            '</tr>';
        }
        // tslint:disable-next-line:max-line-length
        return '<div class="container-fluid"><div class="row"><div class="col-xs-6">' + '<table class="table table-unstriped table-bordered table-hover table-condensed" cellpadding="5" cellspacing="0" border="0" style="margin: 0; padding: 0; width:100%;">' +
            '<tbody>' +
            outputEntreprise +
            '<tr>' +
                '<td class="info">Adresse:</td>' +
                '<td>' + d.format_address + '</td>' +
            '</tr>' +
            '<tr>' +
                '<td class="info">Courriel:</td>' +
                '<td>' + d.email + '</td>' +
            '</tr>' +
            '<tr>' +
                '<td class="info">Description de la panne:</td>' +
                '<td>' + d.reason_panne + '</td>' +
            '</tr>' +
            '<tr>' +
                '<td class="info">Encryption Unité Stockage:</td>' +
                '<td>' + outputEncrypt + '</td>' +
            '</tr>' +
            outputExpeditionMethod +
            '<tr>' +
                '<td class="info">Choix du Support:</td>' +
                '<td>' + d.export_method + '</td>' +
            '</tr>' +
            outputFacturation +
            '</tbody>' +
            // tslint:disable-next-line:max-line-length
            '</table>' + '</div><div class="col-xs-6"><table class="table table-unstriped table-bordered table-hover table-condensed" cellpadding="5" cellspacing="0" border="0" style="margin: 0; padding: 0; width:100%;">' +
            '<tbody>' +
            '<tr>' +
                '<td class="info">Infos disque(s):</td>' +
                '<td>' +
                // tslint:disable-next-line:max-line-length
                        outputDisks +
                '</td>' +
            '</tr>' +
            outputRaid +
            '<tr>' +
                '<td class="info">Système:</td>' +
                '<td>' + d.system + '</td>' +
            '</tr>' +
            '<tr>' +
                '<td class="info">Priorités:</td>' +
                '<td>' +
                    '<ol>' +
                        '<li>' + d.priority_data[0] + '</li>' +
                        '<li>' + d.priority_data[1] + '</li>' +
                        '<li>' + d.priority_data[2] + '</li>' +
                    '</ol>' +
                '</td>' +
            '</tr>' +
            '<tr>' +
                '<td class="info">Informations complémentraires:</td>' +
                '<td>' + d.priority_info + '</td>' +
            '</tr>' +
            '</tbody>' +
            '</table></div></div>';
    }

    $(document).ready(() => {
        const dt = $('#table1').DataTable({
            'paging': true,
            'processing': true,
            'serverSide': true,
            'responsive': true,
            'ajax': {
                beforeSend: function (request) {
                  //request.setRequestHeader('Authorization', 'Bearer' + authToken);
                },
                url: 'https://api.chronodisk.ca/api/dashboard/getalldisks',
                dataType: 'json',
                type: 'POST',
                data: function(d) {
                  start = d.start;
                  length = d.length;
                }
            },
            'dom': `<'row'<'col-sm-4'B><'col-sm-4'l><'col-sm-4'f>>' + '<'row'<'col-sm-12'tr>>' + '<'row'<'col-sm-5'i><'col-sm-7'p>>`,
            'buttons': [
                {
                  'text': 'Rafraîchir',
                  'className': 'btn btn-primary btn-sm',
                  // tslint:disable-next-line:no-shadowed-variable
                  'action': function (e, dt, node, config) {
                      dt.ajax.reload(null, false);
                  }
              }
            ],
            'columns': [
                {
                    'targets': 0,
                    'data': null,
                    'defaultContent': '',
                    'orderable': false,
                    'className': 'select-checkbox'
                },
                { 'data': 'ticket' },
                { 'data': 'contact' },
                { 'data': 'phone_number' },
                { 'data': 'statut' },
                { 'data': 'expedition_method' },
                { 'data': 'manipulation' },
                { 'data': 'date' },
                { 'data': 'type_stockage', render: function(data) {
                    switch (data) {
                        case 'Disquedur':
                            data = 'Disque Dur';
                            break;
                        case 'MemoireFlash':
                            data = 'Mémoire Flash';
                            break;
                        case 'Smartphone':
                            data = 'SmartPhone/Tablette';
                            break;
                    }
                    return data;
                } },
                { 'data': 'statut_disk', render: function(data) {
                    switch (data) {
                        case 'enattente':
                            data = 'En Attente';
                            break;
                        case 'endiagnostic':
                            data = 'En Diagnostic';
                            break;
                        case 'devisenvoyes':
                            data = 'Devis Envoyés';
                            break;
                        case 'devisacceptes':
                            data = 'Devis Acceptés';
                            break;
                        case 'devisrefuses':
                            data = 'Devis Refusés';
                            break;
                        case 'entraitementlogique':
                            data = 'En Traitement Logique';
                            break;
                        case 'ensalleblanche':
                            data = 'En Salle Blanche';
                            break;
                        case 'extractionterminee':
                            data = 'Extraction Terminée';
                            break;
                        case 'enbackup':
                            data = 'En Backup';
                            break;
                        case 'echecs':
                            data = 'Échecs';
                            break;
                        case 'austock':
                            data = 'Au Stock';
                            break;
                        case 'aurecyclage':
                            data = 'Au Recyclage';
                            break;
                        case 'remisauclient':
                            data = 'Remis Au Client';
                            break;
                      } 
                    return data;
                } },
                {
                    'className':      'details-control',
                    'orderable':      false,
                    'data':           null,
                    'defaultContent': ''
                }
            ],
            'columnDefs': [
                {
                    'searchable': false,
                    'orderable': false,
                    'className': 'select-checkbox',
                    'targets':   0
                },
                {
                    'searchable': false,
                    'orderable': false,
                    'targets': 4
                },
                {
                    'searchable': false,
                    'orderable': false,
                    'targets': 6
                },
                {
                    'searchable': false,
                    'orderable': false,
                    'targets': 9
                },
                {
                    'className': 'details-control',
                    'searchable': false,
                    'orderable': false,
                    'targets': 10
                },
            ],
            'select': {
                'style':    'os',
                'selector': 'td:first-child'
            },
            'search': {
                'regex': true
            },
            'order': [[1, 'asc']],
            'language': {
                "sProcessing":     "Traitement en cours...",
                "sSearch":         "Rechercher&nbsp;:",
                "sLengthMenu":     "Afficher _MENU_ &eacute;l&eacute;ments",
                "sInfo":           "Affichage de l'&eacute;l&eacute;ment _START_ &agrave; _END_ sur _TOTAL_ &eacute;l&eacute;ments",
                "sInfoEmpty":      "Affichage de l'&eacute;l&eacute;ment 0 &agrave; 0 sur 0 &eacute;l&eacute;ment",
                "sInfoFiltered":   "(filtr&eacute; de _MAX_ &eacute;l&eacute;ments au total)",
                "sInfoPostFix":    "",
                "sLoadingRecords": "Chargement en cours...",
                "sZeroRecords":    "Aucun &eacute;l&eacute;ment &agrave; afficher",
                "sEmptyTable":     "Aucune donn&eacute;e disponible dans le tableau",
                "oPaginate": {
                    "sFirst":      "Premier",
                    "sPrevious":   "Pr&eacute;c&eacute;dent",
                    "sNext":       "Suivant",
                    "sLast":       "Dernier"
                },
                "oAria": {
                    "sSortAscending":  ": activer pour trier la colonne par ordre croissant",
                    "sSortDescending": ": activer pour trier la colonne par ordre d&eacute;croissant"
                },
                "select": {
                        "rows": {
                            _: "%d lignes séléctionnées",
                            0: "Aucune ligne séléctionnée",
                            1: "1 ligne séléctionnée"
                        } 
                }
            }
        });
      dt.on( 'click', 'tr td.details-control', function () {
          const tr = $(this).closest('tr');
          const row = dt.row( tr );
          const idx = $.inArray( tr.attr('id'), detailRows );
          if ( row.child.isShown() ) {
              tr.removeClass( 'details' );
              row.child.hide();
              // Remove from the 'open' array
              detailRows.splice( idx, 1 );
          } else {
              tr.addClass( 'details' );
              row.child( format( row.data() ) ).show();
              // Add to the 'open' array
              if ( idx === -1 ) {
                  detailRows.push( tr.attr('id') );
              }
          }
      });
        const detailRows = [];
        dt.on( 'draw', function () {
          $.each( detailRows, function ( i, id ) {
              $('#' + id + ' td.details-control').trigger( 'click' );
          } );
      });
    });
    }, 2000);
  }
}